Function startmenu(id)
	
	For i = 0 To 9
		If (titlechar(i)) Then
			FreeEntity(titlechar(i))
			titlechar(i) = 0
		EndIf
	Next
	
	If id = 0 Then
		RotateEntity(camera, 0, 0, 0)
		PositionEntity(camera, 0, 0, -4)
		
		menubackgroundtex = myloadtexture("res20.dat", 1)
		ScaleTexture(menubackgroundtex, 20, 20)
		EntityTexture(menubackground, menubackgroundtex)
		
		menubackgroundtex2 = myloadtexture("res21.dat", 1)
		ScaleTexture(menubackgroundtex2, 20, 20)
		EntityTexture(menubackground2, menubackgroundtex2)
		
		LightColor(levellight, 255, 255, 255)
		AmbientLight(255, 255, 255)
		
		ShowEntity(menubackground)
		ShowEntity(menubackground2)
		ShowEntity(menuselector)
		
		HideEntity(logo1)
		HideEntity(logo2)
	ElseIf id = 1 Then
	
		If Not introvoice Then
			playmysound(sfxtalk(5), 0)
			introvoice = 1
		EndIf
		
		RotateEntity(camera, 0, 0, 0)
		PositionEntity(camera, 0, 0, -4)
		
		menubackgroundtex = myloadtexture("res20.dat", 1)
		ScaleTexture(menubackgroundtex, 20, 20)
		EntityTexture(menubackground, menubackgroundtex)
		
		menubackgroundtex2 = myloadtexture("res21.dat", 1)
		ScaleTexture(menubackgroundtex2, 20, 20)
		EntityTexture(menubackground2, menubackgroundtex2)
		
		LightColor(levellight, 255, 255, 255)
		AmbientLight(255, 255, 255)
		
		ShowEntity(menubackground)
		ShowEntity(menubackground2)
		ShowEntity(menuselector)
		ShowEntity(logo1)
		ShowEntity(logo2)
		
		PositionEntity(logo1, -0.99000001, 1.52, 0)
		EntityAlpha(logo1, 0)
		
		PositionEntity(logo2, 0, 1.52, 0)
		EntityAlpha(logo2, 0)
		
		If (Not currentmenu = 10) And (Not currentmenu = 9) And (Not currentmenu = 7) And doessoundexist Then
			StopChannel(music)
			music = PlayMusic("res4.dat")
			ChannelVolume(music, optionsmusiclevel)
		EndIf
		
		titlechar(0) = CopyEntity(stinkymesh)
		EntityTexture(titlechar(0), stinkytexture)
		RotateEntity(titlechar(0), 45, 190, 0)
		ScaleEntity(titlechar(0), 0.050000001, 0.050000001, 0.050000001)
		PositionEntity(titlechar(0), -0.86000001, 0.40000001, 0.0)
		AnimateMD2(titlechar(0), 1, 0.15000001, 44, 52)
		EntityAlpha(titlechar(0), 0)
		
		titlechar(1) = CopyEntity(loofmesh)
		EntityTexture(titlechar(1), looftexture)
		RotateEntity(titlechar(1), 45, 170, 0)
		ScaleEntity(titlechar(1), 0.039999999, 0.039999999, 0.039999999)
		PositionEntity(titlechar(1), 0.86000001, 0.40000001, 0.0)
		AnimateMD2(titlechar(1), 1, 0.25, 53, 61)
		EntityAlpha(titlechar(1), 0)
		
		titlechar(2) = CopyEntity(cannonmesh)
		RotateEntity(titlechar(2), -90, 90, 20)
		ScaleEntity(titlechar(2), 0.045000002, 0.045000002, 0.045000002)
		PositionEntity(titlechar(2), -1.2, 0.40000001, 0.0)
		EntityAlpha(titlechar(2), 0)
		
		titlechar(3) = CopyEntity(monstermesh(0))
		RotateEntity(titlechar(3), 0, 90, 0)
		ScaleEntity(titlechar(3), 0.02, 0.02, 0.02)
		PositionEntity(titlechar(3), -0.40000001, 0.40000001, 0.0)
		EntityAlpha(titlechar(3), 0)
		
		titlechar(4) = CopyEntity(monstermesh(3))
		RotateEntity(titlechar(4), 0, 180, 0)
		ScaleEntity(titlechar(4), 0.045000002, 0.045000002, 0.045000002)
		PositionEntity(titlechar(4), 0.40000001, 0.40000001, 0.0)
		AnimateMD2(titlechar(4), 1, 0.40000001, 1, 24)
		EntityAlpha(titlechar(4), 0)
		
		titlechar(5) = CopyEntity(monstermesh(1))
		RotateEntity(titlechar(5), -90, 0, 90)
		ScaleEntity(titlechar(5), 0.025, 0.025, 0.025)
		PositionEntity(titlechar(5), 1.2, 0.40000001, 0.0)
		EntityAlpha(titlechar(5), 0)
		
		leveltimer = 0
	EndIf
	
	currentmenu = id
	currentmenuoption = 0
	gamephase = 0
	tweenperiod = 11
	tweentime = MilliSecs() - tweenperiod
	
End Function

Function endmenu()
	
	HideEntity(menubackground)
	HideEntity(menubackground2)
	HideEntity(logo1)
	HideEntity(logo2)
	HideEntity(menuselector)
	
	For let.letter = Each letter
		FreeEntity(let\entity)
		Delete(let)
	Next
	
End Function

Function menuloop()

	If Not currentmenu = 5 Then
		leveltimer = leveltimer + 1
	EndIf
	If currentmenu = 0 Then menuloop0()
	If currentmenu = 1 Then menuloop1()
	If currentmenu = 2 Then menuloop2()
	If currentmenu = 3 Then menuloop3()
	If currentmenu = 4 Then menuloop4()
	If currentmenu = 5 Then menuloop5()
	If currentmenu = 6 Then menuloop6()
	If currentmenu = 7 Then menuloop7()
	If currentmenu = 8 Then menuloop8()
	If currentmenu = 9 Then menuloop9()
	If currentmenu = 10 Then menuloop10()
	If currentmenu = 11 Then
		If language Then
			menuloop11old()
		Else
			menuloop11()
		EndIf
	EndIf
	If currentmenu = 12 Then menuloop12()
	
	If KeyHit(66) Then
		SaveBuffer(FrontBuffer(), "screenshot.bmp")
	EndIf
	
End Function

Function menuloop0()
	
	
	
End Function

Function menuloop1()
	displaytext("v" + versionno1 + "." + "1" + "7", 45, 0, 1, 50)
	fps = leveltimer Mod 200
	
	displaytext("", 46, 1, 1, 62)
	
	If language = 0 Then
		
		centertext("START GAME", 1, 11, 1, 34)
		centertext("THE PLAYGROUND", 1, 12, 1, 35)
		centertext("OPTIONS", 1, 13, 1, 36)
		centertext("ONLINE SOLUTIONS", 1, 14, 1, 37)
		centertext("EXIT TO WINDOWS", 1, 15, 1, 38)
			
	ElseIf language = 1 Then
		
		centertext("SPIEL STARTEN", 1, 11, 1, 34)
		centertext("BEGINNER LEVELS", 1, 12, 1, 35)
		centertext("OPTIONEN", 1, 13, 1, 36)
		centertext("ONLINE HILFE", 1, 14, 1, 37)
		centertext("SPIEL BEENDEN", 1, 15, 1, 38)
		
	ElseIf language = 2 Then
		
		centertext("JOUER", 1, 11, 1, 34)
		centertext("LE TERRAIN DE JEU", 1, 12, 1, 35)
		centertext("OPTIONS", 1, 13, 1, 36)
		centertext("SOLUCES EN LIGNE", 1, 14, 1, 37)
		centertext("SORTIE VERS WINDOWS", 1, 15, 1, 38)
		
	EndIf
	
	If leveltimer Mod 200 >= 100 Then
		centertext("", 1, 17, 1, 39)
	Else
		If language = 0 Then
			centertext("Use Cursor Keys and Enter to Select", 1, 17, 1, 39)
		ElseIf language = 1 Then
			centertext("Benutze die Pfeiltasten und zur Auswahl 'Enter'", 1, 17, 1, 39)
		ElseIf language = 2 Then
			centertext("Pour choisir, utilise les fleches et 'Entree'", 1, 17, 1, 39)
		EndIf
	EndIf
	
	; MORE STOOF
	
	v1 = Len(scrolltext)
	v2 = 0 Mod 50 * v1
	
	;stext$ = Mid(scrolltext, v2 / 50 + 1)
	sx = leveltimer Mod (displaywidth + 50 + Len(scrolltext) * 16)
	displaytext2(scrolltext, -sx, 18, 1, 51)
	;0.37200001 + 
	
	;-0.0020000245
	
	PositionEntity(menuselector, 14 / displaywidth, ((currentmenuoption * -22) - 1) / displayheight, 1.1)
	
	;centertext(currentmenuoption, 0, 0, 1, 100)
	
	Select currentmenuoption
		Case 0
			ScaleSprite(menuselector, 0.15000001, 0.02)
		Case 1
			ScaleSprite(menuselector, 0.222, 0.02)
		Case 2
			ScaleSprite(menuselector, 0.090000004, 0.02)
		Case 3
			ScaleSprite(menuselector, 0.222, 0.02)
		Case 4
			ScaleSprite(menuselector, 0.222, 0.02)
		Case 5
			ScaleSprite(menuselector, 0.24600001, 0.02)
	End Select
	
	v = leveltimer Mod 14000
	
	RotateEntity(titlechar(2), -90, 90, v Mod 360)
	PositionEntity(titlechar(3), -0.40000001, 0.40000001, 0.0)
	ScaleEntity(titlechar(3), 0.2, 0.1, 0.2)
	
	PositionEntity(titlechar(5), 1.2, 0.44999999, 0.0)
	
	RotateEntity(titlechar(5), -90, 10, 90)
	
	If False Then
	
	If v >= 1000 Then
		If v >= 10000 Then
			If v >= 11000 Then
				EntityAlpha(logo1, 0)
				EntityAlpha(logo2, 0)
			Else
				PositionEntity(logo1, -2.99, 0.60000002, 0)
				PositionEntity(logo2, 0, 0.60000002, 0)
				ScaleEntity(logo1, 3, 3, 3)
				ScaleEntity(logo2, 3, 3, 3)
				
				If v >= 10500 Then
					EntityAlpha(logo1, 11000)
					EntityAlpha(logo2, 11000)
				Else
					EntityAlpha(logo1, v - 10000)
					EntityAlpha(logo2, v - 10000)
				EndIf
			EndIf
		Else
			EntityAlpha(logo1, 0)
			EntityAlpha(logo2, 0)
		EndIf
	Else
		;stuf
		
		PositionEntity(logo1, -2.99, 0.60000002, 0)
		PositionEntity(logo2, 0, 0.60000002, 0)
		ScaleEntity(logo1, 3, 3, 3)
		ScaleEntity(logo2, 3, 3, 3)
		If v >= 500 Then
			EntityAlpha(logo1, 1000)
			EntityAlpha(logo2, 1000)
		Else
			EntityAlpha(logo1, v)
			EntityAlpha(logo2, v)
		EndIf
	EndIf
	
	Else
		
		;temp
		EntityAlpha(logo1, 1000)
		EntityAlpha(logo2, 1000)
	
	EndIf
	
	; STUFF HERE
	
	For let.letter = Each letter
		If Not let\visible Then
			ShowEntity(let\entity)
			let\visible = True
		EndIf
	Next
	
	Repeat
		tweenelapsed = MilliSecs() - tweentime
	Until tweenelapsed > tweenperiod
	tweenticks = tweenelapsed / tweenperiod 
	tween = tweenelapsed Mod tweenperiod
		
	For i = 1 To tweenticks
	;While True			

		If tweenelapsed < tweenperiod Then
			Exit
		EndIf
		
		tweentime = tweentime + tweenperiod
		
		If tweenelapsed = tweenticks Then
			CaptureWorld()
		EndIf
		leveltimer = leveltimer + 1;0.001
		
		PositionTexture(menubackgroundtex, leveltimer / 5120, leveltimer / -1024)
		PositionTexture(menubackgroundtex2, leveltimer / 5120, leveltimer / -1024)
		
		;PositionTexture(menubackgroundtex, leveltimer Mod 5120, leveltimer Mod 1024)
		;PositionTexture(menubackgroundtex2, leveltimer Mod 5120, leveltimer Mod 1024)		
		UpdateWorld(1)
		tweenelapsed = tweenelapsed + 1
	Next
	;Wend
	
	RenderWorld(tween)
	Flip()

	If KeyDown(72) Or KeyDown(200) Then	
		If Not cursorkeypressed Then
			playmysound(sfxmenusound(0), 0)
			currentmenuoption = currentmenuoption - 1
			If currentmenuoption = -1 Then
				currentmenuoption = 4
			EndIf
			cursorkeypressed = True
		EndIf
	ElseIf KeyDown(80) Or KeyDown(208) Then
	
		If Not cursorkeypressed Then
			playmysound(sfxmenusound(0), 0)
			currentmenuoption = currentmenuoption + 1
			;Floor(
			If currentmenuoption = 5 Then
				currentmenuoption = 0
			EndIf
			cursorkeypressed = True
		EndIf
		
	ElseIf KeyDown(156) Or KeyDown(28) Then
		If currentmenuoption = 0 Then
			endmenu()
			startmenu(2)
		ElseIf currentmenuoption = 1 Then
			endmenu()
			startmenu(7)
		ElseIf currentmenuoption = 2 Then
			endmenu()
			startmenu(9)
		ElseIf currentmenuoption = 3 Then
			endmenu()
			versionno1 = -999
			gameexit = 1
		ElseIf currentmenuoption = 4 Then
			endmenu()
			startmenu(10)
		ElseIf currentmenuoption = 5 Then
			endmenu()
			versionno = -1
			gameexit = 1
		EndIf
	ElseIf KeyDown(1) Then
		
		If Not cursorkeypressed Then
			cursorkeypressed = 1
			endmenu()
			startmenu(10)
		EndIf
		
	Else
		cursorkeypressed = False
	EndIf
	
End Function

Function menuloop2()
	;temp
	endmenu()
	currentlevel = 0
	startlevelmusic()
	startlevel(currentlevel)
	playmysound(sfxtalk(Rand(0, 3)), 0)
End Function

Function menuloop3()

End Function

Function menuloop4()

End Function

Function menuloop5()

End Function

Function menuloop6()

End Function

Function menuloop7()

End Function

Function menuloop8()

End Function

Function menuloop9()

End Function

Function menuloop10()

End Function

Function menuloop11old()

End Function

Function menuloop11()

End Function

Function menuloop12()

End Function