Function setup()
	
	mygfxmodewidth(0) = 640
	mygfxmodeheight(0) = 480
	mygfxmodewidth(1) = 800
	mygfxmodeheight(1) = 600
	mygfxmodewidth(2) = 1024
	mygfxmodeheight(2) = 768
	mygfxmodewidth(3) = 1280
	mygfxmodeheight(3) = 960
	
	If Not GfxMode3DExists(mygfxmodewidth(mygfxmode), mygfxmodeheight(mygfxmode), (8 * mycolmode) + 8) Then
		mygfxmode = 0
		mycolmode = 1
	EndIf
	
	displaywidth = mygfxmodewidth(mygfxmode)
	displayheight = mygfxmodeheight(mygfxmode)
	oldgfxmode = mygfxmode
	oldwindowed = mywindowed
	
	Graphics3D(displaywidth, displayheight, (8 * mycolmode) + 8, 2 * mywindowed)
	SetBuffer(BackBuffer())
	
	Print("=========================================")
	Print("Wonderland v " + Str(versionno1)) + "." + "1" + "7"
	Print("=========================================")
	
	Print("Copyright (C) 2002-2005 Midnight Synergy")
	
	If language = 1 Then
		Print("WWW.MIDNIGHTSYNERGY.COM")
	Else
		Print("Visit www.midnightsynergy.com for more information.")
	EndIf
	
	Print("")
	
	Print("-----------------------------------------------------")
	Print("This is the full registered version of Wonderland.")
	Print("Please do not pass this copy on to friends or others.")
	Print("Report software piracy at www.midnightsynergy.com")
	Print("-----------------------------------------------------")
	
	Print("")
	
	If language = 1 Then
		Print("Bitte warten...")
	ElseIf language = 2 Then
		Print("Version Francaise: Dominic Richer, St-Francois du Lac")
		Print("")
		Print("Attendez S.V.P....")
	Else
		Print("Loading.... Please Wait")
	EndIf
	
	initpackfile()
	
	watertexture = myloadtexture("graphics\water.jpg", 2)
	conveyortexture1 = myloadtexture("res8.dat", 1)
	conveyortexture2 = myloadtexture("res8.dat", 1)
	RotateTexture(conveyortexture2, 270)
	conveyortexture3 = myloadtexture("res8.dat", 1)
	RotateTexture(conveyortexture3, 180)
	conveyortexture4 = myloadtexture("res8.dat", 1)
	RotateTexture(conveyortexture4, 90)
	
	icetexture = myloadtexture("graphics\ice.jpg", 1)
	icecurvetexture1 = myloadtexture("graphics\icecurve1.jpg", 1)
	icecurvetexture2 = myloadtexture("graphics\icecurve2.jpg", 1)
	icecurvetexture3 = myloadtexture("graphics\icecurve3.jpg", 1)
	icecurvetexture4 = myloadtexture("graphics\icecurve4.jpg", 1)
	lavatexture = myloadtexture("graphics\lava.jpg", 1)
	
	Print(".")
	
	electrotexture = myloadanimtexture("res11.dat", 6, 64, 64, 0, 4)
	rainbowtexture = myloadtexture("graphics\rainbow.jpg", 2)
	
	stinkymesh = myloadmd2("graphics\stinky.md2")
	stinkytexture = myloadtexture("graphics\stinky2.bmp", 1)
	stinkytextureb = myloadtexture("graphics\stinky2b.bmp", 1)
	stinkytexturec = myloadtexture("graphics\stinky2c.bmp", 1)
	stinkytextured = myloadtexture("graphics\stinky2d.bmp", 1)
	HideEntity(stinkymesh)
	
	loofmesh = myloadmd2("graphics\stinky.md2")
	looftexture = myloadtexture("graphics\loof.bmp", 1)
	looftextureb = myloadtexture("graphics\loofb.bmp", 1)
	looftexturec = myloadtexture("graphics\loofc.bmp", 1)
	looftextured = myloadtexture("graphics\loofd.bmp", 1)
	EntityTexture(loofmesh, looftexture, 0, 0)
	ScaleEntity(loofmesh, 0.89999998, 0.69999999, 0.94999999)
	HideEntity(loofmesh)
	
	Print(".")
	
	woodboxmesh = myloadmesh("graphics\box.3ds")
	woodboxtexture = myloadtexture("graphics\woodbox.bmp", 1)
	EntityTexture(woodboxmesh, woodboxtexture)
	ScaleEntity(woodboxmesh, 1.1, 1.1, 1.1)
	HideEntity(woodboxmesh)
	
	steelboxmesh = myloadmesh("graphics\box.3ds")
	steelboxtexture = myloadtexture("graphics\steelbox.bmp", 1)
	EntityTexture(steelboxmesh, steelboxtexture)
	HideEntity(steelboxmesh)
	
	cannonmesh = myloadmesh("graphics\scouge.3ds")
	cannontexture = myloadtexture("graphics\scouge3.bmp", 1)
	RotateEntity(cannonmesh, -90, -90, 0)
	EntityTexture(cannonmesh, cannontexture)
	HideEntity(cannonmesh)
	
	Print(".")
	
	fireballmesh = CreateSphere()
	EntityColor(fireballmesh, 255, 240, 200)
	EntityAlpha(fireballmesh, 0.5)
	ScaleEntity(fireballmesh, 0.2, 0.2, 0.2)
	HideEntity(fireballmesh)	
	
	roundshadowtexture = myloadtexture("graphics\beachballshadow.bmp", 2)
	
	irongatemesh = myloadmesh("graphics\gate.3ds")
	PositionMesh(irongatemesh, 0.0, 0.1, 0.0)
	TurnEntity(irongatemesh, -90, 0, 0)
	ScaleEntity(irongatemesh, 1, 1, 1.3)
	HideEntity(irongatemesh)
	
	monstermesh(0) = myloadmd2("graphics\coily.md2")
	monstertexture(0) = myloadtexture("graphics\coily.bmp", 1)
	ScaleEntity(monstermesh(0), 0.30000001, 0.2, 0.30000001)
	EntityTexture(monstermesh(0), monstertexture(0))
	HideEntity(monstermesh(0))
	
	Print(".")
	
	monstermesh(1) = myloadmesh("graphics\zbot.3ds")
	monstertexture(1) = myloadtexture("graphics\zbot.bmp", 1)
	ScaleEntity(monstermesh(1), 0.60000002, 0.60000002, 0.60000002)
	EntityTexture(monstermesh(1), monstertexture(1))
	HideEntity(monstermesh(1))
	
	monstermesh(3) = myloadmd2("graphics\bomb.md2")
	monstertexture(3) = myloadtexture("graphics\bomb.bmp", 1)
	RotateEntity(monstermesh(3), 0.0, 180.0, 0.0)
	EntityTexture(monstermesh(3), monstertexture(3))
	HideEntity(monstermesh(3))
	
	fishmesh = myloadmesh("graphics\fish.x")
	FitMesh(fishmesh, -0.5, -0.5, -0.5, 0.5, 0.5, 0.5)
	fishtexture = myloadtexture("graphics\fish.bmp", 1)
	EntityTexture(fishmesh, fishtexture)
	HideEntity(fishmesh)
	
	Print(".")
	
	particlemesh(0) = CreateSprite(0)
	particlemesh(1) = createflatsquare(watertexture)
	HideEntity(particlemesh(0))
	HideEntity(particlemesh(1))
	
	particletexture = myloadanimtexture("res18.dat", 2, 32, 32, 0, 12)
	particletexture2 = myloadanimtexture("res19.dat", 4, 32, 32, 0, 2)
	
	breakawaymesh = createflatsquare(rainbowtexture)
	HideEntity(breakawaymesh)
	
	electromesh = createflatsquare(electrotexture)
	HideEntity(electromesh)
	
	Print(".")
	
	itemmesh(0) = myloadmesh("graphics\coin.3ds")
	ScaleEntity(itemmesh(0), 0.80000001, 0.80000001, 0.5)
	itemtexture(0) = myloadtexture("graphics\coin2.bmp", 2)
	itemshadowtexture(0) = myloadtexture("graphics\coinshadow.bmp", 2)
	itemshadowmesh(0) = createflatsquare(itemshadowtexture(0))
	PositionMesh(itemshadowmesh(0), -0.5, 0.0, 0.5)
	ScaleEntity(itemshadowmesh(0), 0.60000002, 0.60000002, 0.1)
	EntityAlpha(itemshadowmesh(0), 0.5)
	HideEntity(itemshadowmesh(0))
	EntityTexture(itemmesh(0), itemtexture(0))
	HideEntity(itemmesh(0))
	
	itemmesh(1) = CreateSphere()
	ScaleEntity(itemmesh(1), 0.5, 0.5, 0.5)
	EntityTexture(itemmesh(1), rainbowtexture)
	HideEntity(itemmesh(1))
	
	itemmesh(2) = CreateSphere()
	ScaleEntity(itemmesh(2), 0.2, 0.2, 0.2)
	HideEntity(itemmesh(2))
	
	itemmesh(3) = myloadmesh("graphics\coin.3ds")
	ScaleEntity(itemmesh(3), 0.80000001, 0.80000001, 0.5)
	itemtexture(3) = myloadtexture("graphics\coin.jpg", 1)
	EntityTexture(itemmesh(3), itemtexture(3))
	HideEntity(itemmesh(3))
	
	Print(".")
	
	buttonontexture = myloadtexture("graphics\button.bmp", 4)
	buttonofftexture = myloadtexture("graphics\buttonoff.bmp", 4)
	
	pillarmesh(0) = myloadmesh("graphics\pillar.3ds")
	pillartexture(0) = myloadtexture("graphics\pillar1.jpg", 1)
	EntityTexture(pillarmesh(0), pillartexture(0))
	RotateEntity(pillarmesh(0), -90, 0, 0)
	HideEntity(pillarmesh(0))
	
	pillarmesh(1) = myloadmesh("graphics\pyramid.3ds")
	pillartexture(1) = myloadtexture("graphics\pillar2.jpg", 1)
	EntityTexture(pillarmesh(1), pillartexture(1))
	RotateEntity(pillarmesh(1), -90, 0, 0)
	HideEntity(pillarmesh(1))
	
	pillarmesh(2) = myloadmesh("graphics\spike.3ds")
	pillartexture(2) = myloadtexture("graphics\pillar2.jpg", 1)
	EntityTexture(pillarmesh(2), pillartexture(2))
	RotateEntity(pillarmesh(2), -90, 0, 0)
	HideEntity(pillarmesh(2))
	
	demotexture(0) = myloadtexture("graphics\demo1.jpg", 4)
	demotexture(1) = myloadtexture("graphics\demo3.jpg", 4)
	demotexture(2) = myloadtexture("graphics\demo4.jpg", 4)
	
	camera = CreateCamera()
	RotateEntity(camera, 0, 0, 0)
	PositionEntity(camera, 0, 0, -4)
	CameraRange(camera, 0.98000002, 140.0)
	CameraZoom(camera, 2.0)
	
	levellight = CreateLight()
	LightColor(levellight, 255, 0, 255)
	PositionEntity(levellight, 100, 100, -100)
	RotateEntity(levellight, 25, -25, 0)
	
	Print(".")
	
	setupfont()
	
	Print(".")
	
	loadsounds()
	
	Print(".")
	
	menusetup()
	
End Function

Function setupFont()
	
	flags = 2
	fonttex(0) = myloadanimtexture("res12.dat", 2, 16, 32, 0, 16)
	If Not fonttex(0) Then
		flags = 6
		fonttex(0) = myloadanimtexture("res12.dat", 6, 16, 32, 0, 16)
	EndIf
	
	fonttex(1) = myloadanimtexture("res13.dat", flags, 16, 32, 0, 16)
	fonttex(2) = myloadanimtexture("res14.dat", flags, 16, 32, 0, 16)
	fonttex(3) = myloadanimtexture("res15.dat", flags, 16, 32, 0, 16)
	fonttex(4) = myloadanimtexture("res16.dat", flags, 16, 32, 0, 16)
	fonttex(5) = myloadanimtexture("res17.dat", flags, 16, 32, 0, 16)
	
End Function

Function loadsounds()
	
	sfxlevellose = myloadsound("sound\death2.wav")
	sfxbreakaway = myloadsound("sound\breakaway.wav")
	sfxboxpush = myloadsound("sound\boxpush.wav")
	sfxboxsplosh = myloadsound("sound\splosh.wav")
	sfxboxexplo = myloadsound("sound\boxexplo.wav")
	sfxteleport = myloadsound("sound\teleport.wav")
	sfxbutton = myloadsound("sound\button.wav")
	sfxbounce = myloadsound("sound\bounce.wav")
	sfxcoilydeath = myloadsound("sound\coilydeath.wav")
	sfxbombexplo = myloadsound("sound\bombexplo.wav")
	
	sfxsingle(0) = myloadsound("sound\electro.wav")
	sfxsingle(1) = myloadsound("sound\fireshot.wav")
	sfxsingle(2) = myloadsound("sound\fireexplo.wav")
	
	sfxstinkycoin = myloadsound("sound\stinkycoin.wav")
	sfxloofcoin = myloadsound("sound\Loofcoin.wav")
	sfxstinkybonus = myloadsound("sound\StinkyBonus.wav")
	sfxloofbonus = myloadsound("sound\LoofBonus.wav")
	sfxlastcoin = myloadsound("sound\lastcoin.wav")
	sfxstinkyend = myloadsound("sound\StinkyEnd.wav")
	sfxloofend = myloadsound("sound\LoofEnd.wav")
	sfxstinkyconvey = myloadsound("sound\StinkyConvey.wav")
	sfxloofconvey = myloadsound("sound\LoofConvey.wav")
	sfxhmmm = myloadsound("sound\slhmmm.wav")
	sfxtime = myloadsound("sound\sltime.wav")
	sfxdeath = myloadsound("sound\sldeath.wav")
	
	sfxtalk(0) = myloadsound("sound\getready.wav")
	sfxtalk(1) = myloadsound("sound\herewego.wav")
	sfxtalk(2) = myloadsound("sound\cmonletsgo.wav")
	sfxtalk(3) = myloadsound("sound\letsdoit.wav")
	sfxtalk(4) = myloadsound("sound\stinkyno.wav")
	sfxtalk(5) = myloadsound("sound\introcmon.wav")
	
	sfxmenusound(0) = myloadsound("sound\menumove.wav")
	sfxmenusound(1) = myloadsound("sound\type.wav")
	
	For i = 0 To 10
		sfxcount(i) = myloadsound("sound\sl" + Str(i) + ".wav")
	Next
	
	sfxtimerbutton = myloadsound("sound\windup.wav")
	sfxice = myloadsound("sound\ice.wav")
	
	For i = 0 To 4
		sfxslice(i) = myloadsound("sound\slice" + Str(i + 1) + ".wav")
	Next
	
	sfxlava = myloadsound("sound\blub.wav")
	
End Function

Function menusetup()
	
	menubackgroundtex = myloadtexture("res20.dat", 1)
	ScaleTexture(menubackgroundtex, 20, 20)
	menubackground = CreatePlane()
	RotateEntity(menubackground, -45, 0, 0)
	PositionEntity(menubackground, 0, 0, 20)
	EntityTexture(menubackground, menubackgroundtex)
	
	menubackground2 = CreatePlane()
	RotateEntity(menubackground2, -45, 0, 0)
	PositionEntity(menubackground2, 0, 0, 10)
	EntityTexture(menubackground2, menubackgroundtex)
	EntityAlpha(menubackground2, 0.5)
	
	logotex1 = myloadtexture("graphics\wonderlanda.bmp", 4)
	logo1 = createflatsquare(logotex1)
	RotateEntity(logo1, -90, 0, 0)
	
	logotex2 = myloadtexture("graphics\wonderlandb.bmp", 4)
	logo2 = createflatsquare(logotex2)
	RotateEntity(logo2, -90, 0, 0)
	
	HideEntity(menubackground)
	HideEntity(menubackground2)
	
	menuselector = CreateSprite(camera)
	menuselectortex = myloadtexture("graphics\menubar.jpg", 1)
	ScaleSprite(menuselector, 0.34999999, 0.02)
	TranslateEntity(menuselector, -0.090000026, 80.355003, 0.0)
	EntityTexture(menuselector, menuselectortex)
	EntityAlpha(menuselector, 0.60000002)
	
	worldleveltexture = myloadtexture("graphics\levelsigns2.bmp", 4)
	worldleveltexture2 = myloadtexture("graphics\levelsigns2b.bmp", 4)
	
End Function