AppTitle("Wonderland")

;----------------------------------------------;
; Includes                                     ;
;----------------------------------------------;

Include "includes.bb"


;----------------------------------------------;
; Initialize                                   ;
;----------------------------------------------;

loadoptions()
setup()
startmenu(1)

Local musicIsOn = True

While Not gameexit
	
	If Not CallDLL("user32.dll", "getactivewindow") Then
	
		If Not gamephase Then
			If Not musicIsOn Then
				If doessoundexist Then
					ChannelVolume(music, optionsmusiclevel)
					musicIsOn = True
				EndIf
			EndIf
			
			menuloop()
		EndIf
		
		If gamephase = 1 Then
			
			If Not musicIsOn Then
				If doessoundexist Then
					ChannelVolume(music, optionsmusiclevel)
					musicIsOn = True
				EndIf
			EndIf
			
			maingameloop()
			
			If KeyDown(1) Then
				playmysound(sfxmenusound(0), 0)
				While KeyDown(1)
					; empty on purpose
				Wend
				startmenu(5)
			EndIf
			
		EndIf
	
	Else
		If musicIsOn Then
			If doessoundexist Then
				ChannelVolume(music, 0)
				musicIsOn = False
			EndIf
		EndIf
		Delay(100)
	EndIf
Wend

;----------------------------------------------;
; Cleanup                                      ;
;----------------------------------------------;

; Cleanup Temporary Files
dir = ReadDir(CurrentDir())
Repeat
	file$ = NextFile(dir)
	
	If Lower(Right(file, 4)) = ".tmp" Or Lower(Right(file, 4)) = ".3ds" Or Lower(Right(file, 2)) = ".x" Then
		DeleteFile(file)
	EndIf
Until file = ""
CloseDir(dir)

; Stop Graphics
ClearWorld(True, True, True)
EndGraphics()

; Fade out music
If doessoundexist Then
	For i = 1 To 100
		ChannelVolume(music, (100 - i) / 100)
		Delay(10)
	Next
	StopChannel(music)
EndIf

If versionno1 = -999 Then
	ExecFile("http://www.midnightsynergy.com/wonderland/hints")
	End()
EndIf

If versionno1 = -998 Then
	ExecFile("http://www.midnightsynergy.com")
	End()
EndIf

If versionno1 = -1 Then
	ExecFile("http://www.midnightsynergy.com/wonderland/order1.htm")
EndIf

If versionno1 = -2 Then
	ExecFile("http://www.midnightsynergy.com/games.htm")
EndIf

If versionno1 = -3 Then
	ExecFile("mailto:bonus@midnightsynergy.com")
EndIf

End()